local oldUnit = Unit
Unit = Class(oldUnit) {
    OnTeleportUnit = function(self, teleporter, location, orientation)
        for num, brain in ArmyBrains do
            local unitList = brain:GetListOfUnits(categories.ANTITELEPORT, false)
            for i, unit in unitList do
                --	if it's an ally, then we skip.
                if not IsEnemy(self:GetArmy(), unit:GetArmy()) then
                    continue
                end
                local selfpos = self:GetPosition()
                local noTeleDistance = unit:GetBlueprint().Defense.NoTeleDistance
                local atposition = unit:GetPosition()
                local targetdest = VDist2(location[1], location[3], atposition[1], atposition[3])
                local sourcecheck = VDist2(selfpos[1], selfpos[3], atposition[1], atposition[3])
                local id = self:GetEntityId()
                if noTeleDistance and noTeleDistance > targetdest then
                    FloatingEntityText(id,'Teleport target blocked.')
                    return
                elseif noTeleDistance and noTeleDistance >= sourcecheck then
                    FloatingEntityText(id,'Teleport source blocked.')
                    return
                end
            end
        end
        oldUnit.OnTeleportUnit(self, teleporter, location, orientation)
    end,

}


